LNMPワンタッチインストールスクリプト(コンパイル方式)


#!/bin/bash
# -------------------------------------------------------------------------------
# filename:         lamp_install.sh
# version:          centos6.5_32;nginx1.6.2;mysql5.1;php5.4
# date:             2016/03/20
# author:           ecithy
# mail:             [email protected]
# website:          www.xiaoleizi.com  
# weixingonghao       IT
# pre_operate:      yum install -y wget gcc lrzsz epel-release unix2dos dos2unix            
# copyright:        free             
# -------------------------------------------------------------------------------

check()
{
    if [ $(id -u) != '0' ];then
        echo "you aren't root,stop install...";
        exit 1;  
    else
        echo "you are root,continue...";    
    fi
    
    if [ `arch` != 'i686' ];then
        echo "you aren't 32 system,stop install..."
        exit 1;
    else
        echo "you are 32 system,continue..."; 
    fi
    
    sleep 5
}

init()
{
    #shutdown SELINUX    
    setenforce 0
    #remove iptables
    iptables -F && service iptables save
    test -d /usr/local/src || mkdir -p /usr/local/src 
}

mysql_install()
{
    
    cd /usr/local/src/
    wget http://mirrors.sohu.com/mysql/MySQL-5.1/mysql-5.1.73-linux-i686-glibc23.tar.gz    
    tar zxvf mysql-5.1.73-linux-i686-glibc23.tar.gz
    mv mysql-5.1.73-linux-i686-glibc23 /usr/local/mysql  
    useradd -s /sbin/nologin mysql   
    mkdir -p /data/mysql; chown -R mysql /data/mysql         
    cd /usr/local/mysql/
    ./scripts/mysql_install_db --user=mysql --datadir=/data/mysql   
    if [ $? -ne 0 ];then
        echo "MySQL  install fail, stop..."
        exit 1   
    fi    
    cp /usr/local/mysql/support-files/my-large.cnf /etc/my.cnf
    cp /usr/local/mysql/support-files/mysql.server /etc/init.d/mysqld
    chmod 755 /etc/init.d/mysqld
    sed -ir 's#basedir=#basedir=/usr/local/mysql#g' /etc/init.d/mysqld
    sed -ir 's#datadir=#datadir=/data/mysql#g' /etc/init.d/mysqld
    chkconfig --add mysqld;chkconfig mysqld on;/etc/init.d/mysqld start  
    if [ $? -ne 0 ];then
        echo "MySQL  install fail, stop..."
        exit 1
    fi
    
    sleep 5   
}

php_install()
{
    cd /usr/local/src/
    yum install -y libxml2-devel libjpeg libjpeg-devel libpng libpng-devel freetype freetype-devel bzip2 bzip2-devel openssl openssl-devel libmcrypt-devel pcre-devel
    rpm -ivh "http://www.aminglinux.com/bbs/data/attachment/forum/month_1211/epel-release-6-7.noarch.rpm"
    useradd -s  /sbin/nologin php-fpm
    wget http://cn2.php.net/get/php-5.4.45.tar.bz2/from/this/mirror
    mv  mirror php-5.4.45.tar.bz2
    tar jxvf  php-5.4.45.tar.bz2   
    cd /usr/local/src/php-5.4.45
    ./configure \
         --prefix=/usr/local/php \
         --with-config-file-path=/usr/local/php/etc  \
         --enable-fpm\
         --with-fpm-user=php-fpm\
          --with-fpm-group=php-fpm\
         --with-mysql=/usr/local/mysql\
         --with-mysql-sock=/tmp/mysql.sock \
         --with-libxml-dir \
         --with-gd \
         --with-jpeg-dir \
         --with-png-dir \--with-freetype-dir \
         --with-iconv-dir \
         --with-zlib-dir \
         --with-mcrypt \
         --enable-soap \
         --enable-gd-native-ttf \
         --enable-ftp\
         --enable-mbstring \
         --enable-exif \
         --disable-ipv6
         
    if [ $? -ne 0 ];then
        echo "php configure fail , stop... "
        exit 1
    fi 
    make && make install
    if [ $? -ne 0 ];then
        echo "php make fail , stop... "
        exit 1
    fi 
    cp php.ini-production /usr/local/php/etc/php.ini 
    cat > /usr/local/php/etc/php-fpm.conf<<EOF
    [global]
    pid = /usr/local/php/var/run/php-fpm.pid
    error_log = /usr/local/php/var/log/php-fpm.log
    [www]
    listen = /tmp/php-fcgi.sock
    user = php-fpm
    group = php-fpm
    pm = dynamic
    pm.max_children = 50
    pm.start_servers = 20
    pm.min_spare_servers = 5
    pm.max_spare_servers = 35
    pm.max_requests = 500
    rlimit_files = 1024 
     listen.mode=777
EOF
    cp /usr/local/src/php-5.4.45/sapi/fpm/init.d.php-fpm /etc/init.d/php-fpm
    mv /usr/local/php/etc/php-fpm.conf.default  /usr/local/php/etc/php-fpm.conf     
    chmod 755 /etc/init.d/php-fpm 
    chkconfig --add php-fpm
    service php-fpm start 
    if [ $? -ne 0 ];then
        echo "php start fail, stop... "
        exit 1
    fi 
    chkconfig php-fpm on 
    
}

nginx_install()
{
    cd /usr/local/src/
    wget http://nginx.org/download/nginx-1.6.2.tar.gz   
    tar zxvf nginx-1.6.2.tar.gz 
    cd nginx-1.6.2
    ./configure \
        --prefix=/usr/local/nginx \
        --with-http_realip_module \
        --with-http_sub_module \
        --with-http_gzip_static_module \
        --with-http_stub_status_module  \
        --with-pcre
        
    if [ $? -ne 0 ];then
        echo "nginx configure fail , stop... "
        exit 1
    fi 
    make && make install
    if [ $? -ne 0 ];then
        echo "nginx make fail , stop... "
        exit 1
    fi
    #start nginx
    /usr/local/nginx/sbin/nginx
    
    cat > /etc/init.d/nginx <<EOF
        #!/bin/bash
        # chkconfig: - 30 21
        # description: http service.
        # Source Function Library
        . /etc/init.d/functions
        # Nginx Settings

        NGINX_SBIN="/usr/local/nginx/sbin/nginx"
        NGINX_CONF="/usr/local/nginx/conf/nginx.conf"
        NGINX_PID="/usr/local/nginx/logs/nginx.pid"
        RETVAL=0
        prog="Nginx"

        start() {
                echo -n $"Starting $prog: "
                mkdir -p /dev/shm/nginx_temp
                daemon $NGINX_SBIN -c $NGINX_CONF
                RETVAL=$?
                echo
                return $RETVAL
        }

        stop() {
                echo -n $"Stopping $prog: "
                killproc -p $NGINX_PID $NGINX_SBIN -TERM
                rm -rf /dev/shm/nginx_temp
                RETVAL=$?
                echo
                return $RETVAL
        }

        reload(){
                echo -n $"Reloading $prog: "
                killproc -p $NGINX_PID $NGINX_SBIN -HUP
                RETVAL=$?
                echo
                return $RETVAL
        }

        restart(){
                stop
                start
        }

        configtest(){
            $NGINX_SBIN -c $NGINX_CONF -t
            return 0
        }

        case "$1" in
          start)
                start
                ;;
          stop)
                stop
                ;;
          reload)
                reload
                ;;
          restart)
                restart
                ;;
          configtest)
                configtest
                ;;
          *)
                echo $"Usage: $0 {start|stop|reload|restart|configtest}"
                RETVAL=1
        esac

        exit $RETVAL 
    
EOF
    chmod 755 /etc/init.d/nginx
    chkconfig --add nginx
    chkconfig nginx on 
}

nginx_resolve_php()
{
    > /usr/local/nginx/conf/nginx.conf
    cat > /usr/local/nginx/conf/nginx.conf<<EOF
    user nobody nobody;
    worker_processes 2;
    error_log /usr/local/nginx/logs/nginx_error.log crit;
    pid /usr/local/nginx/logs/nginx.pid;
    worker_rlimit_nofile 51200;

    events
    {
        use epoll;
        worker_connections 6000;
    }

    http
    {
        include mime.types;
        default_type application/octet-stream;
        server_names_hash_bucket_size 3526;
        server_names_hash_max_size 4096;
        log_format combined_realip '$remote_addr $http_x_forwarded_for [$time_local]'
        '$host "$request_uri" $status'
        '"$http_referer" "$http_user_agent"';
        sendfile on;
        tcp_nopush on;
        keepalive_timeout 30;
        client_header_timeout 3m;
        client_body_timeout 3m;
        send_timeout 3m;
        connection_pool_size 256;
        client_header_buffer_size 1k;
        large_client_header_buffers 8 4k;
        request_pool_size 4k;
        output_buffers 4 32k;
        postpone_output 1460;
        client_max_body_size 10m;
        client_body_buffer_size 256k;
        client_body_temp_path /usr/local/nginx/client_body_temp;
        proxy_temp_path /usr/local/nginx/proxy_temp;
        fastcgi_temp_path /usr/local/nginx/fastcgi_temp;
        fastcgi_intercept_errors on;
        tcp_nodelay on;
        gzip on;
        gzip_min_length 1k;
        gzip_buffers 4 8k;
        gzip_comp_level 5;
        gzip_http_version 1.1;
        gzip_types text/plain application/x-javascript text/css text/htm application/xml;

    server
    {
        listen 80;
        server_name localhost;
        index index.html index.htm index.php;
        root /usr/local/nginx/html;

        location ~ \.php$ {
            include fastcgi_params;
            fastcgi_pass unix:/tmp/php-fcgi.sock;
            fastcgi_index index.php;
            fastcgi_param SCRIPT_FILENAME /usr/local/nginx/html$fastcgi_script_name;
        }

    }

    }
EOF
    /usr/local/nginx/sbin/nginx -t
    service nginx start
    cat > /usr/local/nginx/html/info.php<<EOF
    <?php
        phpinfo();
EOF
    curl localhost && echo "php resolve OK" || echo "php resolve fail"
 
 
}

lnmp_install()
{
    check
    init
    mysql_install
    php_install
    nginx_install
    nginx_resolve_php
}


lnmp_install 2>&1 | tee ~/install.log